/*
 * LineFollower.c
 *
 * Created: 16.05.2013 13:05:14
 *  Author: Irina && Diana
 */ 

#include <avr/io.h>
#include <util/delay.h>

#define F_CPU 16000000

#define SPEED 250

#define R  1
#define L 2
#define UP 3
#define LAST 4

int a, b, c, d;

void init (void)
{
	
//  PORTA este pentru senzorii  si este input

	PORTA = 0xff;
	DDRA = 0x00;

//  PORTD este pentru motoare

	PORTD |= (1 << PD4) | (1 << PD5) | (1 << PD6) | (1 << PD7);
	DDRD |= (1 << PD4) | (1 << PD5) | (1 << PD6) | (1 << PD7);
 
//  initializare timer 1 cu fast PWM pe 8 biti
 
	TCCR1A |=	(1<<WGM10) | (1<<COM1A1) | (1<<COM1B1) ; 
	TCCR1B |=	(1<<WGM12) | (1<<CS11);
	
//  initializare timer 2 cu fast PWM

	TCCR2A |= (1<<WGM20) | (1<<WGM21)  | (1<<COM2A1) | (1<<COM2B1);
	TCCR2B |=  (1<<CS21);
	
}

void make_step (unsigned char dir,  int speed)
{
	// realizez ultima miscare
	if(dir == LAST) {
		OCR1B = a;
		OCR1A = b;
		OCR2B = c;
		OCR2A = d;
	}

	if(dir == R) {
		a = OCR1B = 0;
		b = OCR1A = 0;
		c = OCR2B = speed;
		d = OCR2A = 0;
	}

	if(dir == L) {
		a = OCR1B = speed;
		b = OCR1A = 0;
		c = OCR2B = 0;
		d = OCR2A = 0;
	}

	if(dir == UP) {
		a = OCR1B = speed;
		b = OCR1A = 0;
		c = OCR2B = speed;
		d = OCR2A = 0;
	}
}

int main()
{
	int left, right, i, distance;
	unsigned char sensors;
	
	// initializare pini output/input
	init ();
	
	OCR1B = 0;
	OCR2A = 0;
	OCR2B = 0;
	OCR1A = 0;

	while (1) {
		_delay_ms(100);
	
		sensors = PINA;
		left = -1;
		right = -1;
		
		for (i = 0; i < 8; i++) {
			if (bit_is_set (sensors, i) && left == -1)
					left = i;
		}

		for (i = 7; i >= 0; i--) {
			if (bit_is_set (sensors, i) && right == -1)
					right = i;
		}
	
		// daca se detecteaza doar alb sau doar negru
		if (left + right == -2) {
			// realizez ultima miscare
			make_step (LAST, 250);
			continue;
		}
		distance = right - left;

		if (left > 3 + distance/2 ) {
			make_step (L, 150 + left * 10);
			continue;
		}
	
		if (right < 4 - distance/2) {
			make_step (R, 150 + (7 - right) * 10);
			continue;
		}
		
		make_step (UP, 250);
	}
	
	return 0;
}
